# ../addons/eventscripts/corelib/callblock/callblock.py

''' Version 1.0 by L'In20Cible '''

import es
import cmdlib


arguments = list()


def getVariable(cvarname):
   returnvalue = None
   if es.exists("variable", cvarname) or es.getInt("eventscripts_autocreate"): # Follows 'eventscripts_autocreate' if the variable doesn't exists...
      returnvalue = es.ServerVar(cvarname)
   else:
      es.printmsg("The var '" + cvarname + "' could not be set.\n") # The variable could not be set...
   return returnvalue
   
   
def callblock_callback(parameters): # Syntax: callblock <script/block> [argument-1] [argument-2] [...]
   global arguments
   if len(parameters) >= 1:
      arguments = list(parameters)
      blockname = parameters[0].replace("\\", "/").strip()
      if es.addons.Blocks.has_key(blockname):
         es.addons.Blocks[blockname](*arguments[1:]) # Calls the function and lets python throwing exceptions...
      else: # This is not a python function registered as a block so lets EventScripts try...
         es.doblock(blockname)
   else: # The syntax is not right so print the syntax to the console...
      es.printmsg("Syntax: callblock <script/block> [argument-1] [argument-2] [...]\n")
      
cmdlib.registerServerCommand("callblock", callblock_callback, "Executes a block with the passed arguments.")


def getargc_callback(parameters): # Syntax: getargc <variable>
   if len(parameters) == 1:
      variable = getVariable(parameters[0])
      if variable is not None: # Checks if the variable is valid first...
         variable.set(len(arguments) - 1) # Sets the variable to the length of the current arguments list...
   else: # The syntax is not right so print the syntax to the console...
      es.printmsg("Syntax: getargc <variable>\n")
      
cmdlib.registerServerCommand("getargc", getargc_callback, "Gets the count of arguments passed to the last called block.")


def getargs_callback(parameters): # Syntax: getargs <variable>
   if len(parameters) == 1:
      variable = getVariable(parameters[0])
      if variable is not None: # Checks if the variable is valid first...
         variable.set(" ".join(arguments[1:]).replace('"', "")) # Create a string from the arguments...
   else: # The syntax is not right so print the syntax to the console...
      es.printmsg("Syntax: getargs <variable>\n")
      
cmdlib.registerServerCommand("getargs", getargs_callback, "Create a string from the arguments passed to the last called block.")


def getargv_callback(parameters): # Syntax: getargv <variable> <index>
   if len(parameters) == 2:
      variable = getVariable(parameters[0])
      if variable is not None: # Checks if the variable is valid first...
         if parameters[1].isdigit():
            index = int(parameters[1])
            if index in range(len(arguments)): # Checks if the index is valid...
               variable.set(arguments[index])
   else: # The syntax is not right so print the syntax to the console...
      es.printmsg("Syntax: getargv <variable> <index>\n")
      
cmdlib.registerServerCommand("getargv", getargv_callback, "Gets a single argument from the arguments passed to the last called block.")